#!/bin/bash

#  This script is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2 as
#  published by the Free Software Foundation.
#
#  See the COPYING and AUTHORS files for more details.

# Read in library functions
if [ "$(type -t patch_file_name)" != function ]
then
	if ! [ -r /usr/share/quilt/lib/patchfns ]
	then
		echo "Cannot read library /usr/share/quilt/lib/patchfns" >&2
		exit 1
	fi
	. /usr/share/quilt/lib/patchfns
fi

usage()
{
	echo "Usage: quilt remove [-p patch] {file} ..."
	if [ x$1 = x-h ]
	then
		cat <<EOF

Remove one or more files to the topmost or named patch.
Files that are modified by patches on top of the specified
patch cannot be removed.

-p patch
	Patch to add files to.

EOF
		exit 0
	else
		exit 1
	fi
}

options=`getopt -o p:h -- "$@"`

if [ $? -ne 0 ]
then
	usage
fi

eval set -- "$options"

while true
do
	case "$1" in
	-p)
		opt_patch=$2
		shift 2 ;;
	-h)
		usage -h ;;
	--)
		shift
		break ;;
	esac
done

if [ $# -lt 1 ]
then
	usage
fi

patch=$(stripit $opt_patch)
if [ -z "$patch" ]
then
	patch=$(top_patch)
fi
if [ -z "$patch" ]
then
	echo "No patches applied"
fi

if ! is_applied $patch
then
	echo "Patch $patch is not applied"
	exit 1
fi

status=0
for file in $*
do
	if ! file_in_patch $file $patch
	then
		echo "File $file is not in patch $patch"
		status=1
		continue
	fi

	next_patch=$(next_patch_for_file $patch $file)
	if [ -n "$next_patch" ]
	then
		echo "File $file modified by patch $next_patch"
		status=1
		continue
	fi

	# Restore file from backup
	if ! /usr/share/quilt/lib/backup-files -s -B .pc/$patch/ -r $file
	then
		echo "Failed to remove file $file from patch $patch"
		status=1
		continue
	fi
	
	pc_file=$(pc_file_name $patch)
	tmpfile=$(mktemp /tmp/patch-scripts.XXXXXX) &&
	grep -v '^'"$(quote_re $file)"'$' $pc_file > $tmpfile &&
	mv -f $tmpfile $pc_file
	rm -f $tmpfile

	echo "File $file removed from patch $patch"
done
exit $status
